//Frames are from 0 to 14 for 15 frames total

#version 3.7;

global_settings{ assumed_gamma 1.0 }

#include "macroTimeSetter.inc"

camera{
        orthographic
        location <0, 0, -20>
        look_at 0
        sky y
        right 2.1*x
        up 2.1*y
}

light_source{ <1, 1, -8>*1000000 color srgb 1 }

#declare time = clock;

#declare GoldCol = color srgb <1, 0.6, 0>;
#declare CyanCol = color srgb < 0, 1, 1>;
#declare BlueCol = color srgb < 0, 0.2, 1>;
#declare WhiteCol = color srgb 1;

#declare SphereScale = 0;
AffineTimeSetterBoundOnly(0, 7,         0.25, 1, SphereScale, time)
AffineTimeSetterBoundOnly(7, LastFrameNum, 1, 1, SphereScale, time)

#declare FinalCircleWidth = 4 / SquareSize / SphereScale ;

#declare CyanRadius = 0;
AffineTimeSetterBoundOnly(0, 7,  0.01, image_width / 4, CyanRadius, time)
AffineTimeSetterBoundOnly(7, 14, image_width / 4, 0.01, CyanRadius, time)

#declare CyanPatIndex = 1;
//AffineTimeSetterBoundOnly(0, 32, 1, 0, CyanPatIndex, CyanRadius)
//AffineTimeSetterBoundOnly(0, 7,  0, 1 / CyanRadius / image_width / 2, CyanPatIndex, time)
//AffineTimeSetterBoundOnly(7, 14, 1 / CyanRadius / image_width / 2, 0, CyanPatIndex, time)

#declare CyanPattern = density{wrinkles color_map{[0.0 color srgb 0 ]
                                                  [0.65 color srgb 0 ]
                                                  [0.65 CyanCol ]
                                                  [1.0 CyanCol ]
                                        }
                            scale 0.1
                            warp{ turbulence 0.4 }
                        }

#declare RadialDensity = density{ radial color_map{ [0.0 color srgb 0]
                                                    [0.9 color srgb 0]
                                                    [0.9 BlueCol ]
                                                    [1 BlueCol ]
                                                }
                            frequency 4
                        }

sphere{0, 1 hollow no_shadow pigment{ color srgbft <0, 0, 0, 0, 1> } 
    interior{
        //Cyan disc/particules at center
        media{
            emission 4 samples 1, 30 intervals 20
            density{ spherical density_map{
                                            [0.0 color srgb 0]
                                            [CyanPatIndex color srgb 0]
                                            [CyanPatIndex CyanPattern]
                }
            }
        }
        //Yellow gold extern circle
        media{ emission 4 samples 1, 30 intervals 20
            density{ cylindrical density_map{
                                    [0.01 color srgb 0 ]
                                    [0.01 GoldCol ]
                                    [(0.01 + FinalCircleWidth) GoldCol]
                                    [(0.01 + FinalCircleWidth) color srgb 0]
                                    [1 color srgb 0]
                                }
                rotate 90*x
            }
        }
        //electrical links between center and border
        media{ emission 4 samples 1, 30 intervals 20
            density{ cylindrical density_map{
                                    [0 color srgb 0]
                                    [0.02 RadialDensity ]
                                    [1 RadialDensity ]
                                 }
                rotate 90*x
                warp{ turbulence 0.25 }
                rotate (time / LastFrameNum * 90) * z
            }
        }
    }
    scale SphereScale
}

//#debug concat("CyanPatIndexValue: ", str(CyanPatIndex, 8, 8), "  CyanRadius: ", str(CyanRadius, 8, 8), "\n" )
//#debug concat("FinalCircleWidth: ", str(FinalCircleWidth, 8, 8), "\n" )